# HTessellationSettings

## Types

| `HTessellationLOD`

## Fields

| `TessLODExtraLow`
| `TessLODLow`
| `TessLODMedium`
| `TessLODHigh`
| `TessLODExtraHigh`
| `TessLODUserDefined`
| `TessLODControlledPrecision`
`HTessellationLOD` | `m_TessLod`
double | `m_dChordHeightRatio`
double | `m_dAngleToleranceDeg`
double | `m_dMinimalTriangleAngleDeg`
double | `m_dMaxChordHeight`
bool | `m_bAccurateTessellation`
bool | `m_bDoNotComputeNormalsInAccurateTessellation`
bool | `m_bAccurateTessellationWithGrid`
double | `m_dAccurateTessellationWithGridMaximumStitchLength`
bool | `m_bKeepUVPoints`
bool | `m_bUseHeightInsteadOfRatio`
double | `m_dMaximalTriangleEdgeLength`

## Functions

| `HTessellationSettings`

## Detailed Description

class HTessellationSettings

  Specifies the settings of tessellation in Import.

  Public Types

  enum HTessellationLOD

    Values:

    enumerator TessLODExtraLow

      Extra Low level: when selected, these members are automatically defined with the following values: ChordHeightRatio = 50, AngleToleranceDeg = 40.

    enumerator TessLODLow

      Low level: when selected, these members are automatically defined with the following values: ChordHeightRatio = 600, AngleToleranceDeg = 40.

    enumerator TessLODMedium

      Medium level: when selected, these members are automatically defined with the following values: ChordHeightRatio = 2000, AngleToleranceDeg = 40.

    enumerator TessLODHigh

      High level: when selected, these members are automatically defined with the following values: ChordHeightRatio = 5000, AngleToleranceDeg = 30.

    enumerator TessLODExtraHigh

      Extra High level: when selected, these members are automatically defined with the following values: ChordHeightRatio = 10000, AngleToleranceDeg = 20.

    enumerator TessLODUserDefined

      User Defined level: when selected, these members should be defined: m_dChordHeightRatio if m_bUseHeightInsteadOfRatio is set to false, m_dMaxChordHeight if m_bUseHeightInsteadOfRatio is set to true, m_dAngleToleranceDeg. Be very careful when using m_dMaxChordHeight because a too small value would generate a huge tessellation.

    enumerator TessLODControlledPrecision

      Controlled Precision level: when selected, these members should be defined: m_dAngleToleranceDeg, m_dMaxChordHeight, m_dMinimalTriangleAngleDeg.

      Deprecated:

        This is a deprecated feature.

  Public Functions

  inline HTessellationSettings()

  Public Members

  HTessellationLOD m_TessLod
  double m_dChordHeightRatio

    Specifies the ratio of the diagonal length of the bounding box to the chord height. A value of 50 means that the diagonal of the bounding box is 50 times greater than the chord height. Values can range from 50 to 10,000. Higher values will generate more accurate tessellation.

  double m_dAngleToleranceDeg

    Specifies the maximum angle between two contiguous tessellation segments describing the curve of a topological edge for every face.

    During tessellation, the curve describing the edge of a topological face will be approximated using straight line segments. m_dAngleToleranceDeg is the maximum angle between two consecutive segments.

    Allowable values range from 10 to 40. Lower values will result in greater accuracy.
  double m_dMinimalTriangleAngleDeg

    Specifies the angle between two contiguous segments of wire edges for every face. Allowable values range from 10 through 30.

    Deprecated:

      This is a deprecated feature.

  double m_dMaxChordHeight

    Specifies the maximum distance between the original geometric surface specified in the CAD file and the resulting tessellation. Be careful, very small values can generate very large tessellation files.

    Conversely, very large values can generate inaccurate tessellation. In such cases, it may be better to use the

    `m_dChordHeightRatio` member to scale this value relative to the object that’s being tessellated.

    Note

    `m_dMaxChordHeight` is ignored if `m_bUseHeightInsteadOfRatio` isn’t set to true.

  bool m_bAccurateTessellation

    Accurate tessellation. Uses standard parameters. ‘false’ indicates the tessellation is set for visualization. Setting this value to ‘true’ will generate tessellation more suited for analysis. Can be used with all TessellationLevelOfDetails.

  bool m_bDoNotComputeNormalsInAccurateTessellation

    Do not compute surface normals in accurate tessellation.

  bool m_bAccurateTessellationWithGrid

    Enable accurate tessellation with faces inner points on a grid.

  double m_dAccurateTessellationWithGridMaximumStitchLength

    Maximal grid stitch length. Disabled if value is 0. Be careful, a too small value can generate a huge tessellation.

  bool m_bKeepUVPoints

    Keep parametric points as texture points.

  bool m_bUseHeightInsteadOfRatio

    Use m_dMaxChordHeight instead of m_dChordHeightRatio if m_eTessellationLevelOfDetail = kA3DTessLODUserDefined.

  double m_dMaximalTriangleEdgeLength

    Maximal length of the edges of triangles. Disabled if value is 0. Be careful, a too small value can generate a huge tessellation.